--   AnnounceIt   --
--    03giant     --

-- Define Variables
TITAN_ANNOUNCE_ID =  "AnnounceIt";
TITAN_ANNOUNCE_VERSION = "0.1.6";
TITAN_ANNOUNCE_MENU_TEXT = "AnnounceIt v0.1.6";
TITAN_ANNOUNCE_TOOLTIP = "AnnounceIt! ";
TITAN_ANNOUNCE_FREQUENCY = 1;
TITAN_ANNOUNCE_MESSAGE_LIMIT = 20
TITAN_ANNOUNCE_MESSAGE_FIELDS_LIMIT = 5

-- Binding Variables
BINDING_HEADER_ANNOUNCEIT = "AnnounceIt";
BINDING_NAME_ANNOUNCEIT1 = "Message 1";
BINDING_NAME_ANNOUNCEIT2 = "Message 2";
BINDING_NAME_ANNOUNCEIT3 = "Message 3";
BINDING_NAME_ANNOUNCEIT4 = "Message 4";
BINDING_NAME_ANNOUNCEIT5 = "Message 5";

-- Load the Addon
function TitanPanelAnnounceItButton_OnLoad()
	this.registry = { 
		id = TITAN_ANNOUNCE_ID,
		menuText = TITAN_ANNOUNCE_MENU_TEXT,
		category = "Interface",
		buttonTextFunction = "TitanPanelAnnounceItButton_GetButtonText", 
		tooltipTitle = TITAN_ANNOUNCE_TOOLTIP,
		tooltipTextFunction = "TitanPanelAnnounceItButton_GetTooltipText",
		icon = "Interface\\Icons\\INV_Misc_Orb_01",
		iconWidth = 16,
		frequency = TITAN_ANNOUNCE_FREQUENCY, 
		savedVariables = {
			ShowIcon = 1,
			ShowLabelText = 1,
		}
	};
	if (announce_Message == nil) then announce_Message = {}; end
	local i;
	for i=1,TITAN_ANNOUNCE_MESSAGE_LIMIT,1 do
		if (announce_Message[i] == nil) then
			announce_Message[i]={};
			announce_Message[i].title=""; --title of the message
			announce_Message[i].text={};
			announce_Message[i].label=i; --message ID
			announce_Message[i].chan=1;
			announce_Message[i].active=0; --availiblity in main menu
			for t=1,TITAN_ANNOUNCE_MESSAGE_FIELDS_LIMIT,1 do
				announce_Message[i].text[t]="";
			end
		end
	end

	if ( DEFAULT_CHAT_FRAME ) then 
		DEFAULT_CHAT_FRAME:AddMessage("AnnounceIt "..TITAN_ANNOUNCE_VERSION.." - Loaded.", 0.0, 1.0, 0.0);
	end
end

-- Make the menus
function TitanPanelRightClickMenu_PrepareAnnounceItMenu()

	if ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) then

		-- Write menu 2nd level menu items
		local d;
		for d=1,TITAN_ANNOUNCE_MESSAGE_LIMIT,1 do

			if (UIDROPDOWNMENU_MENU_VALUE == "EDITITEM" ) then

				TitanPanelRightClickMenu_AddCommand(d..". "..announce_Message[d].title, announce_Message[d].label, "TitanPanelAnnounceIt_EditMessage",UIDROPDOWNMENU_MENU_LEVEL);
			end
		end
	else

		TitanPanelRightClickMenu_AddTitle(TitanPlugins[TITAN_ANNOUNCE_ID].menuText);

		-- Write top level menu items
		local k;
		for k=1,TITAN_ANNOUNCE_MESSAGE_LIMIT,1 do
			if ( announce_Message[k].active == 1) then
				TitanPanelRightClickMenu_AddCommand(announce_Message[k].title, announce_Message[k].label, "TitanPanelAnnounceIt_SendMessage");
			end
		end

		TitanPanelRightClickMenu_AddSpacer();

		-- Write menu directories 
		info = {};
		info.text = "Edit Messages";
		info.hasArrow = 1;
		info.value = "EDITITEM";
		UIDropDownMenu_AddButton(info);

		TitanPanelRightClickMenu_AddSpacer();

		-- Generic function to hide the plugin
		TitanPanelRightClickMenu_AddToggleIcon(TITAN_ANNOUNCE_ID);
		TitanPanelRightClickMenu_AddToggleLabelText(TITAN_ANNOUNCE_ID);

		TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, TITAN_ANNOUNCE_ID, TITAN_PANEL_MENU_FUNC_HIDE);
	end
end

-- populate and open the edit box with the selected message
function TitanPanelAnnounceIt_EditMessage()

	messageID = this.value;
	local i;
	for i=1,TITAN_ANNOUNCE_MESSAGE_FIELDS_LIMIT,1 do
		getglobal("AnnounceItSetMessage_Text"..i):SetText(announce_Message[messageID].text[i]);
		getglobal("AnnounceItSetMessage_Chan"..i):SetChecked(0);
	end
	AnnounceItSetMessage_Label:SetText(announce_Message[messageID].title);
	getglobal("AnnounceItSetMessage_Master_Status"):SetChecked(announce_Message[messageID].active);
	getglobal("AnnounceItSetMessage_Chan"..announce_Message[messageID].chan):SetChecked(1);
	active_message_id = messageID;
	AnnounceItSetMessage_Header4:SetText(TITAN_ANNOUNCE_MENU_TEXT);
	AnnounceItSetMessage:Show();
end

-- Take the message and send it
function TitanPanelAnnounceIt_SendMessage(k)

	if ( this == nil ) then
		z = k;
	else
		z = this.value;
	end

	if ( announce_Message[z].chan == 1 ) then
		DEFAULT_CHAT_FRAME:AddMessage("Testing: "..announce_Message[z].title, 1.0, 0.0, 0.0);
		local h
		for h=1,TITAN_ANNOUNCE_MESSAGE_FIELDS_LIMIT,1 do
			DEFAULT_CHAT_FRAME:AddMessage(announce_Message[z].text[h], 1.0, 0.0, 0.0);
		end
	end
	if ( announce_Message[z].chan == 4 ) then
		local h
		for h=1,TITAN_ANNOUNCE_MESSAGE_FIELDS_LIMIT,1 do
			SendChatMessage(announce_Message[z].text[h], "SAY", nil);
		end
	end
	if ( announce_Message[z].chan == 6 ) then
		local h
		for h=1,TITAN_ANNOUNCE_MESSAGE_FIELDS_LIMIT,1 do
			SendChatMessage(announce_Message[z].text[h], "YELL", nil);
		end
	end
	if ( announce_Message[z].chan == 5 ) then
		local channelid = GetChannelName("GuildRecruitment - City");
		local h
		for h=1,TITAN_ANNOUNCE_MESSAGE_FIELDS_LIMIT,1 do
				SendChatMessage(announce_Message[z].text[h], "CHANNEL", nil, channelid);
		end
	end
	if ( announce_Message[z].chan == 2 ) then
		local h
		for h=1,TITAN_ANNOUNCE_MESSAGE_FIELDS_LIMIT,1 do
			SendChatMessage(announce_Message[z].text[h], "GUILD", nil);
		end
	end
	if ( announce_Message[z].chan == 3 ) then
		if ( UnitInRaid("player") ) then
			local h
			for h=1,TITAN_ANNOUNCE_MESSAGE_FIELDS_LIMIT,1 do
				SendChatMessage(announce_Message[z].text[h], "RAID", nil);
			end
		else
			local h
			for h=1,TITAN_ANNOUNCE_MESSAGE_FIELDS_LIMIT,1 do
					SendChatMessage(announce_Message[z].text[h], "PARTY", nil);
			end
		end
	end
	if ( announce_Message[z].chan < 1 or announce_Message[z].chan > 5 ) then
		DEFAULT_CHAT_FRAME:AddMessage("ANNOUNCE WARNING: Error in sending "..announce_Message[z].title, 1.0, 0.0, 0.0);
		DEFAULT_CHAT_FRAME:AddMessage("Could not determine valid chat type!", 1.0, 0.0, 0.0);
	end
end

-- save the edit box values to the addon variables
function AnnounceIt_Save()

	if (active_message_id < 0 or active_message_id > TITAN_ANNOUNCE_MESSAGE_LIMIT) then 
		active_message_id=-1;
		return;
	end

	announce_Message[active_message_id].active = 0;
	announce_Message[active_message_id].active = AnnounceItSetMessage_Master_Status:GetChecked();
	announce_Message[active_message_id].title = AnnounceItSetMessage_Label:GetText();

	local i;
	for i=1,TITAN_ANNOUNCE_MESSAGE_FIELDS_LIMIT,1 do
		if (getglobal("AnnounceItSetMessage_Chan"..i):GetChecked()) then
			announce_Message[active_message_id].chan = i;
		end
		announce_Message[active_message_id].text[i] = getglobal("AnnounceItSetMessage_Text"..i):GetText();
	end 

	active_message_id = -1;
end

-- text for button on Titan bar
function TitanPanelAnnounceItButton_GetButtonText()
	if (TitanGetVar(TITAN_ANNOUNCE_ID, "ShowLabelText")) then
		return "AnnounceIt";
	else
		return "";
	end
end

-- tooltip text for button on Titan bar
function TitanPanelAnnounceItButton_GetTooltipText()
	return "Version "..TITAN_ANNOUNCE_VERSION;
end
